HDU 1260 Tickets【线性dp】

Jesus, what a great movie! Thousands of people are rushing to the cinema. However, this is really a tuff time for Joe who sells the film tickets. He is wandering when could he go back home as early as possible.
A good approach, reducing the total time of tickets selling, is let adjacent people buy tickets together. As the restriction of the Ticket Seller Machine, Joe can sell a single ticket or two adjacent tickets at a time.
Since you are the great JESUS, you know exactly how much time needed for every person to buy a single ticket or two tickets for him/her. Could you so kind to tell poor Joe at what time could he go back home as early as possible? If so, I guess Joe would full of appreciation for your help.
Input
There are N(1<=N<=10) different scenarios, each scenario consists of 3 lines:

  1. An integer K(1<=K<=2000) representing the total number of people;
  2. K integer numbers(0s<=Si<=25s) representing the time consumed to buy a ticket for each person;
  3. (K-1) integer numbers(0s<=Di<=50s) representing the time needed for two adjacent people to buy two tickets together.
    Output
    For every scenario, please tell Joe at what time could he go back home as early as possible. Every day Joe started his work at 08:00:00 am. The format of time is HH:MM:SS am|pm.
    Sample Input
    2
    2
    20 25
    40
    1
    8
    Sample Output
    08:00:40 am
    08:00:08 am
    居然自己写出来又一遍过了,开心
    经验:找规律,主要是开始列前四个的组成情况,就发现:
    dp[i]=min(dp[i-1]+a[i],dp[i-2]+b[i-1]);
    就很赞很开心很开心
    因为我好久都习惯错几个小时了,别人却那么厉害,都不敢碰ACM了,现在调整状态,看到自己还是可以的,很开心很开心,在现在特殊的心情下。
#include<stdio.h>
#include<string.h>
#include<algorithm>
#define mem(a,b) memset(a,b,sizeof(a))
#define inf 0x3f3f3f3f
#define N 2003
using namespace std;
int a[N],b[N],dp[N];//单人,双人(用前者序号)记录,dp 
void trans(int t)//把秒换为时间输出 
{
    
    
	int h,m,s;
	s=t%60;
	t/=60;
	m=t%60;
	t/=60;
	h=8+t;
	if(h<12){
    
    
		printf("%02d:%02d:%02d am\n",h,m,s);
	}else{
    
    
		printf("%02d:%02d:%02d am\n",h-1,m,s);
	}
}
int main()
{
    
    
	//FILE*fp=fopen("text.in","r");//------记得最后注释掉!! 
	int n;
	scanf("%d",&n);
	//fscanf(fp,"%d",&n);
	while(n--){
    
    
		int t=0;
		int k;
		scanf("%d",&k);
		//fscanf(fp,"%d",&k);
		for(int i=1;i<=k;i++){
    
    
			//fscanf(fp,"%d",&a[i]);
			scanf("%d",&a[i]);
		}
		for(int i=1;i<k;i++){
    
    
			//fscanf(fp,"%d",&b[i]);
			scanf("%d",&b[i]);
		}
		dp[0]=0;
		dp[1]=a[1];
		for(int i=2;i<=k;i++){
    
    
			dp[i]=min(dp[i-1]+a[i],dp[i-2]+b[i-1]);
		}
		trans(dp[k]);
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_51945248/article/details/113946861